#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    6
#property indicator_color1     Lime
#property indicator_color2     Red
#property indicator_color3     Green
#property indicator_color4     Maroon
#property indicator_color5     Red
#property indicator_color6     Lime
#property indicator_level1     0
#property indicator_levelstyle STYLE_DOT
#property indicator_levelcolor PaleVioletRed

//
//
//
//
//

extern string TimeFrame            = "Current time frame";
extern double Length               = 50;
extern double SmoothLength         = 2.0;
extern double SmoothPhase          = 0;
extern bool   SmoothDouble         = true;
extern int    Lag                  = 20;
extern int    NumberOfComputations = 2;
extern int    NumberOfBars         = 500;
extern int    Price                = PRICE_CLOSE;
extern bool   Interpolate          = true;
extern bool   alertsOn             = false;
extern bool   alertsOnCurrent      = true;
extern bool   alertsMessage        = true;
extern bool   alertsSound          = false;
extern bool   alertsEmail          = false;

//
//
//
//
//

double upB[];
double upB2[];
double loB[];
double loB2[];
double upK[];
double loK[];
double value[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//
//
//
//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
  IndicatorBuffers(8);
      SetIndexBuffer(0,upB);   SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,2);
      SetIndexBuffer(1,loB);   SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,2);  
      SetIndexBuffer(2,upB2);  SetIndexStyle(2,DRAW_HISTOGRAM,EMPTY,2); 
      SetIndexBuffer(3,loB2);  SetIndexStyle(3,DRAW_HISTOGRAM,EMPTY,2);
      SetIndexBuffer(4,upK);   SetIndexStyle(4,DRAW_ARROW,    EMPTY,1); SetIndexArrow(4,159);
      SetIndexBuffer(5,loK);   SetIndexStyle(5,DRAW_ARROW,    EMPTY,1); SetIndexArrow(5,159);
      SetIndexBuffer(6,value);
      SetIndexBuffer(7,trend);

      //
      //
      //
      //
      //
         
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
   
      //
      //
      //
      //
      //
      
  IndicatorShortName(timeFrameToString(timeFrame)+ "  ssa squeeze of jurik ("+DoubleToStr(Length,2)+")");
   
   return(0);
  }

//
//
//
//
//  
  
int deinit(){return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
  {
  
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMax(MathMin(Bars-counted_bars,Bars-1),Lag);
         if (returnBars) { upB[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {   
      for(i=limit;i>=0;i--)
      {
      
         double d     = LinearRegressionSlope(Length,i);
         double dPrev = LinearRegressionSlope(Length,i+1);
      
         value[i] = d;      
         if(d>0) {
            if ((dPrev>0) && (dPrev > d)){ upB2[i]=d; upB[i] = 0; } else { upB[i]= d; upB2[i] = 0; }
        
            loB[i]=0;
            loB2[i]=0;
         
         } else {
      
            if ((dPrev<0) && (dPrev < d)){ loB2[i]=d; loB[i] = 0; } else { loB[i]= d; loB2[i] = 0; }
            upB[i]=0;
            upB2[i]=0;
  
         }
      
         double diff = iCustom(NULL,0,"SSA of price",Lag,NumberOfComputations,NumberOfBars,Price,0,i);
         double std  =  iCustom(NULL,0,"SSA of price",Lag,NumberOfComputations,NumberOfBars,Price,0,i+1);
         double bbs  = diff-std;
		
         trend[i] = trend[i+1];
            if(bbs > 0) trend[i] =  1;
            if(bbs < 0) trend[i] = -1;
   		
            if(bbs < 0) {
               upK[i] = 0;
               loK[i] = EMPTY_VALUE;
            } else {
               loK[i] = 0;
               upK[i] = EMPTY_VALUE;
            }
         }         
      manageAlerts();
      return(0);
  }
  
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         upB[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,SmoothLength,SmoothPhase,SmoothDouble,Lag,NumberOfComputations,NumberOfBars,Price,0,y);
         loB[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,SmoothLength,SmoothPhase,SmoothDouble,Lag,NumberOfComputations,NumberOfBars,Price,1,y);
         upB2[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,SmoothLength,SmoothPhase,SmoothDouble,Lag,NumberOfComputations,NumberOfBars,Price,2,y);
         loB2[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,SmoothLength,SmoothPhase,SmoothDouble,Lag,NumberOfComputations,NumberOfBars,Price,3,y);
         upK[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,SmoothLength,SmoothPhase,SmoothDouble,Lag,NumberOfComputations,NumberOfBars,Price,4,y);
         loK[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,SmoothLength,SmoothPhase,SmoothDouble,Lag,NumberOfComputations,NumberOfBars,Price,5,y);
         value[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,SmoothLength,SmoothPhase,SmoothDouble,Lag,NumberOfComputations,NumberOfBars,Price,6,y);
         trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,SmoothLength,SmoothPhase,SmoothDouble,Lag,NumberOfComputations,NumberOfBars,Price,7,y);
               
         //
         //
         //
         //
         //
                        
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
            for(int k = 1; k < n; k++)
            {
               value[i+k] = value[i] + (value[i+n]-value[i])*k/n;
               if (loB[i]!=0)  loB[i+k]  = value[i+k];
               if (loB2[i]!=0) loB2[i+k] = value[i+k];
               if (upB[i]!=0)  upB[i+k]  = value[i+k];
               if (upB2[i]!=0) upB2[i+k] = value[i+k];
            }
   }
   manageAlerts();
   return(0);         
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" squeeze me trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," squeeze me "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
//
//
//
//
//

int    lrsperiod=EMPTY_VALUE;
double lrssumX;
double lrssumXSqr;
double lrsdivisor;

//
//
//
//
//

double LinearRegressionSlope(int len,int shift)
{
   double LinearRegSlope;
   double SumXY = 0;
   double SumY  = 0;

   //
   //
   //
   //
   //

   if (lrsperiod != len)
   {
      lrsperiod  = len;
      lrssumX    = lrsperiod * (lrsperiod-1) / 2;
      lrssumXSqr = lrsperiod * (lrsperiod-1) * (2 * lrsperiod - 1) / 6;
      lrsdivisor = MathPow(lrssumX,2) - lrsperiod * lrssumXSqr;
   }

   //
   //
   //
   //
   //

   for (int i=0; i<lrsperiod; i++)
   {
     double price  = iMA(NULL,0,1,0,MODE_EMA,Price,i+shift);
            SumXY += i*price;
            SumY  +=   price;
   }
   if( lrsdivisor != 0 ) 
         	LinearRegSlope = iDSmooth((lrsperiod * SumXY - lrssumX * SumY)/lrsdivisor,SmoothLength,SmoothPhase,SmoothDouble,i,0);
   else     LinearRegSlope = iDSmooth(0,                                              SmoothLength,SmoothPhase,SmoothDouble,i,0);
   return  (LinearRegSlope);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double wrk[][20];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iDSmooth(double price, double length, double phase, bool isDouble, int i, int s=0)
{
   if (isDouble)
         return (iSmooth(iSmooth(price,MathSqrt(length),phase,i,s),MathSqrt(length),phase,i,s+10));
   else  return (iSmooth(price,length,phase,i,s));
}

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

